Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_LibraryObject

    java.lang.Object
      oracle.ifs.server.S_LibraryObject

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, Traceable

Direct Known Subclasses:
  S_TieLibraryObject

    public abstract class S_LibraryObject

extends java.lang.Object
implements IfsEventHandler, LibraryObjectInterface

The S_LibraryObject class is the server side base class for all CM SDK objects.

(Published)

Field Summary
`static int` | `CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY`
`static int` | `CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP`
`static int` | `CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES`
`static int` | `CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP`
`static int` | `CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP`
`static int` | `CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION`
`static int` | `CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT`
`static int` | `CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT`
`static int` | `CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT`
`static int` | `CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES`
`static int` | `CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY`
`static int` | `CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION`
`static int` | `CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT`
`static int` | `CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT`
`static int` | `CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT`
`static int` | `CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES`
`static int` | `CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY`
`static int` | `CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP`
`static int` | `CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP`
`static int` | `CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION`
`static int` | `CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT`
`static int` | `CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT`
`static int` | `CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY`
`static int` | `CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY`
`static int` | `CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT`
`static int` | `CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES`
`static int` | `CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY`
`static int` | `CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION`
`static int` | `CASCADE_OP_UNDEFINED`
`static int` | `CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES`
`static int` | `CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP`
`static int` | `CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP`
`static int` | `CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION`
`static int` | `CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT`
`static int` | `CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT`
`static int` | `CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT`
`static int` | `CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES`
`static int` | `CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY`
`static int` | `CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION`
`static int` | `CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT`
`static int` | `CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT`
`static int` | `CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT`
`static int` | `CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY`
`static int` | `CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY`
`static int` | `CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY`
`static java.lang.String` | `DEFAULT_RENDERER`
`protected java.lang.Long` | `m_ClassId`
`protected java.lang.Long` | `m_Id`
`protected S_LibrarySession` | `m_Session`

Constructor Summary
`protected` | `S_LibraryObject(S_LibrarySession session)` Construct a S_LibraryObject object that does not yet exist inthe database.
`protected` | `S_LibraryObject(S_LibrarySession session, java.lang.Long classId)` This constructor is called during object creation (i.e., this Library Object does not yet exist in the database).
`protected` | `S_LibraryObject(S_LibrarySession session, S_LibraryObjectData data)` Constructs a S_LibraryObject object.

Method Summary
`protected void` | `applyValueDefault(S_LibraryObjectDefinition def)` Sets default values for any attributes which have a ValueDefault and for which no value is specified in the definition.
`protected void` | `associatedPostFree(OperationState opState, S_LibraryObjectDefinition def)` An extensibility point, subclasses override to have postFree extensibility after extendedPostFree and manipulate associated objects
`protected void` | `associatedPostInsert(OperationState opState, S_LibraryObjectDefinition def)` an extensibility point, subclasses override to have postinsert extensibility after extendedPostInsert and manipulate associated objects
`protected void` | `associatedPreInsert(OperationState opState, S_LibraryObjectDefinition def)` an extensibility point, subclasses override to have preinsert extensibility after extendedPreInsert and manipulate associated objects
`protected void` | `cascadeCopy(OperationState opState, S_LibraryObjectDefinition def, S_LibraryObject clone)` Cascade operations to be performed before copying an object.
`protected void` | `cascadeFree(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before freeing an object.
`protected void` | `cascadeUpdate(OperationState opState, S_LibraryObjectDefinition def)` Cascade operations to be performed before updating an object.
`protected void` | `checkRequiredForInsert(S_LibraryObjectDefinition def)` Checks whether all required attributes of the object being created have been set in the specified definition.
`protected void` | `checkSettable(S_LibraryObjectDefinition def)` Checks to ensure the attributes in the specfied definition are user settable.
`protected static void` | `clearArrayTypeAttributeValues(S_Attribute attribute, S_LibrarySession session)` This variant is used by S_ClassObject.removeAttribute.
`protected void` | `clonePublicObjectAttribute(OperationState opState, S_LibraryObjectDefinition sdef, java.lang.String attrname)` Copies an attribute in a definition.
`protected static java.lang.Long[]` | `constructIdArray(S_LibraryObject[] objs)` Construct an array of object IDs from an array of S_LibraryObjects.
`protected static java.lang.Long[]` | `constructIdArray(java.util.Vector vector)` Construct an array of object IDs from a Vector of S_LibraryObjectData objects.
`S_LibraryObject` | `copy(OperationState opState)` Make a copy of the target object.
`S_LibraryObject` | `copy(OperationState opState, S_LibraryObjectDefinition def)` Make a copy of the target object.
`protected static void` | `copyVectorToLibraryObjectArray(S_LibrarySession sess, java.util.Vector vector, S_LibraryObject[] objs)` Fill the specified S_LibraryObject array with S_LibraryObjects constructed from a corresponding set of S_LibraryObjectData obejcts.
`S_PolicyPropertyBundle` | `createDefaultPolicyPropertyBundle()` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`S_PropertyBundle` | `createDefaultPropertyBundle()` Creates a PropertyBundle for a SystemObject or SchemaObject.
`protected S_LibraryObjectData` | `createInstance(OperationState opState, S_LibraryObjectDefinition def)` Create a new instance.
`protected void` | `deleteRows()` Delete the row from each table for this instance.
`protected void` | `deriveDefinition(S_LibraryObjectDefinition def)` Add to the S_LibraryObjectDefinition for this class.
`protected java.lang.String` | `deriveOwnerUniqueName(AttributeValue avName, AttributeValue avOwner)` Derives a "owner based unique name", which is a composite of an object which acts as an owner for scoping purposes, and the object name.
`protected java.lang.String` | `deriveOwnerUniqueName(AttributeValue avName, AttributeValue avOwner, java.lang.String delim)` Derives a "owner based unique name", which is a composite of an object which acts as an owner for scoping purposes, and the object name.
`protected void` | `deriveUppercasedAttribute(S_LibraryObjectDefinition def, java.lang.String attrname, java.lang.String derivedAttrame)` Derives a system-set attribute from a base attribute, if this base attribute is defined in the specified definition.
`protected S_ClassDomain` | `determineClassDomain(S_AttributeData attributeData, S_LibraryObjectDefinition def)` Return the ClassDomain that is in force for the specified Attribute data.
`protected S_Policy` | `determinePolicy(java.lang.String operationName)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`protected S_Policy` | `determinePolicy(java.lang.String operationName, S_LibraryObjectDefinition def)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`protected S_ValueDefault` | `determineValueDefault(S_AttributeData attributeData, S_LibraryObjectDefinition def)` return the ValueDefault that is in force for the specified Attribute data.
`protected S_ValueDomain` | `determineValueDomain(AttributeValue av, S_ClassObjectData classData, S_LibraryObjectDefinition def)` Return the ValueDomain that is in force for the specified AttributeValue.
`void` | `dispose()` Disposes this instance, by nulling the Id and Class Id.
`java.io.Serializable` | `DYNLockRows(java.io.Serializable payload)` Lock the rows from each table for this instance.
`boolean` | `equals(S_LibraryObject item)` Compares whether two LibraryObjects are the same IFS object.
`void` | `executePolicyOperation(java.lang.String opName, OperationState opState, S_LibraryObjectDefinition def)` Execute Policy operation.
`protected void` | `extendedPostFree(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed after freeing an object.
`protected void` | `extendedPostInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Operations to be performed after creating an object.
`protected void` | `extendedPostUpdate(OperationState opState, S_LibraryObjectDefinition def)` Extended operations to be performed after updating an object.
`protected void` | `extendedPreCopy(OperationState opState, S_LibraryObjectDefinition sdef)` Operations to be performed before creating a copy of an object.
`protected void` | `extendedPreFree(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed before freeing an object.
`protected void` | `extendedPreInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Extensibility point to perform actions prior to the creation of a new CM SDK object.
`protected void` | `extendedPreUpdate(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed before updating an object.
`protected static S_Policy` | `findPolicyFromPropertyBundleAv(S_LibrarySession sess, AttributeValue av, java.lang.String operationName)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`protected void` | `free(OperationState opState)` Permanently delete an object.
`void` | `free(OperationState opState, S_LibraryObjectDefinition def)` Permanently delete an object.
`AttributeValue` | `getAttribute(java.lang.String attr_name)` Return an AttributeValue object that holds the value of the requested attribute.
`AttributeValue` | `getAttributeByUpperCaseName(java.lang.String attr_name)` Gets the attribute value for the specified attribute.
`java.lang.String` | `getAuditCertificateName()` Gets the name to use in an audit certificate.
`java.lang.Long` | `getAuditDomainContext()` Gets the domain context to use for auditing.
`S_Folder` | `getAuditEventFolderContext()` Gets the folder context for the target of an Audit Event.
`protected S_ClassObjectData` | `getClassData()` Gets the object's class's Data object.
`java.lang.Long` | `getClassId()` Gets the object's class ID (a long).
`java.lang.String` | `getClassName()` Gets the object's class's name.
`S_ClassObject` | `getClassObject()` Gets the object's ClassObject.
`protected S_LibraryObjectData` | `getData()` Returns the data representation of the object
`protected S_LibraryObjectDefinition` | `getDefinition()` Construct a S_LibraryObjectDefinition object that represents the target object.
`protected java.util.Vector` | `getEffectivePolicyActionContexts(java.lang.String operation)` Gets the set of policies, as PolicyActionContexts, applied to this LibraryObject, either explicitly (through its PolicyLists) or implicitly (through the ClassPolicyLists of its classobject hierarchy) for the specified operation.
`java.util.Vector` | `getEffectivePolicyListElements(java.lang.String operation)` Gets the set of policies, as PolicyListElements, applied to this LibraryObject, either explicitly (through its PolicyLists) or implicitly (through the ClassPolicyLists of its classobject hierarchy) for the specified operation.
`protected AttributeValue` | `getEventualAttributeByUpperCaseName(java.lang.String attrname, S_LibraryObjectDefinition def)` Gets the attribute value for the specified attribute from either the target object or from the specified definition.
`java.lang.Long` | `getId()` Gets the object's numeric ID (a long).
`protected LibraryConnection` | `getLibraryConnection()` Return the database connection.
`java.lang.String` | `getName()` Returns the Name of this object, or null of this object does not have a NAME attribute.
`protected ObjectReferenceAttributeValue` | `getObjectReferenceAttribute(java.lang.String attrname)` Gets the value of a ObjectReference attribute.
`S_PropertyBundle` | `getPropertyBundle()` Gets the S_PropertyBundle for this SystemObject.
`AttributeValue` | `getPropertyValue(java.lang.String key)` Returns a property from the S_PropertyBundle associated with this instance.
`java.lang.String` | `getResourceString(java.lang.String key)` Gets the resource string for the specified key.
`java.lang.String` | `getResourceString(java.lang.String key, java.lang.Object[] params)` Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.
`protected S_LibraryService` | `getService()` getService() - return the S_LibraryService which created the S_LibrarySession from which this object was created.
`S_LibrarySession` | `getSession()` Returns the current S_LibrarySession.
`LibrarySessionInterface` | `getSessionInterface()` Gets the LibrarySessionInterface for this S_LibraryObject.
`TraceLogger` | `getTraceLogger()` Gets the trace logger of this object's session.
`protected void` | `handleCascade(OperationState opState, S_LibraryObject source, int cascadeType, S_LibraryObjectDefinition sdef, java.lang.Object customArg)` Handle a cascaded operation initiated by (usually) another object.
`void` | `handleEvent(IfsEvent event)` Handles the specified event.
`int` | `hashCode()` Returns a hashcode value for the LibraryObject.
`boolean` | `hasNameAttribute()` Returns true if this object is an instance of a class that has a NAME attribute, and false otherwise.
`protected void` | `insertReferenceAttributes(S_LibraryObjectDefinition def)` Resolve any Reference attributes into content and content references during object creation.
`protected void` | `insertRow(AttributeValue[] avs, S_ClassObjectData clssdata)` ???
`protected void` | `insertRows(S_LibraryObjectDefinition def)` Update the rows from each table for this instance.
`void` | `invalidateState()` Invalidates any information cached for this object.
`java.lang.Object` | `invokeOperation(OperationContext opContext)` Invoke an operation.
`protected java.lang.Object` | `invokePolicyMethod(java.lang.String methodName, java.lang.Object[] args, java.lang.String[] argClassPaths)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`boolean` | `isAuditCertificateSecured()` Gets whether an audit certificate for the target object should be secured, meabing it should be restricted to administrators.
`protected boolean` | `isBroadcastCreateEventEnabled()` Returns indication as to whether create events should be posted.
`boolean` | `isInstanceOf(S_ClassObject clss)` Determine if this is an instance of the specified S_ClassObject.
`protected void` | `issueCascade(S_LibraryObject target, OperationState opState, S_LibraryObject source, int cascadeType, S_LibraryObjectDefinition sdef, java.lang.Object customArg)` Issue a cascaded operation request to another object.
`boolean` | `isTraced(int channel, int level)` Gets whether tracing is enabled for the specified channel and level.
`protected void` | `lockRows()` Lock the rows from each table for this instance.
`void` | `postEvent(int eventType, int eventStatus)` Posts an event of the specified type and status.
`void` | `postEvent(int eventType, int eventSubtype, int eventStatus, long longPayload)` Posts an event of the specified type, subtype, and status.
`protected void` | `postFree(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed after freeing an object.
`protected void` | `postInsert(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed after inserting a new object.
`protected void` | `postUpdate(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed after updating an object.
`protected void` | `preFree(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed before freeing an object.
`protected void` | `preInsert(OperationState opState, S_LibraryObjectDefinition def)` Prepare operation for create instance.
`protected void` | `preUpdate(OperationState opState, S_LibraryObjectDefinition def)` perform pre-update operations on an object.
`java.io.Reader` | `renderAsReader(java.lang.String rendererType, java.lang.String rendererName, java.util.Hashtable options)` Deprecated. iFS 9.0.3 see release notes for more information
`java.io.InputStream` | `renderAsStream(java.lang.String rendererType, java.lang.String rendererName, java.util.Hashtable options)` Deprecated. iFS 9.0.3 see release notes for more information
`void` | `setAttribute(AttributeValue attr_value)` Set the object's attribute to the specified value.
`void` | `setAttribute(java.lang.String attr_name, AttributeValue attr_value)` Set the object's attribute to the specified value.
`protected void` | `setAttributes(S_LibraryObjectDefinition def)` Set the object's attributes to the specified values.
`java.lang.String` | `toString()` If this is an instance of a class that has a name attribute, return getName(); else, return super.toString().
`void` | `trace(int channel, int level, java.lang.String payload)` Issues a trace request to the trace logger.
`void` | `update(OperationState opState, S_LibraryObjectDefinition def)` update an object in the context of an Operation.
`protected void` | `updateRows(S_LibraryObjectDefinition def)` Update the rows from each table for this instance.
`protected void` | `verifyCanCreate(S_LibraryObjectDefinition def)` Verifies that the instance can be created.
`protected void` | `verifyCanFree()` Verifies that the instance can be freed.
`protected void` | `verifyCanGetContent(S_ContentObject co)` Verifies that the user has getContent permission on this object
`protected void` | `verifyCanSetContent()` Verifies that the user has setContent permission on this object
`protected void` | `verifyCanSetPolicy()` Verifies that Policies can be updated on the instance.
`protected void` | `verifyCanUpdate()` Verifies that the instance can be updated.
`protected void` | `verifyWriteableTransactionInProgress()` verify that we're in a Writeable transaction.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### CASCADE_OP_UNDEFINED

    public static final int CASCADE_OP_UNDEFINED

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP

    public static final int CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

    public static final int CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT

    public static final int CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT

    public static final int CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT

    public static final int CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION

    public static final int CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION

    public static final int CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION

    public static final int CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES

    public static final int CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES

    public static final int CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES

    public static final int CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT

    public static final int CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT

    public static final int CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT

    public static final int CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION

    public static final int CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION

    public static final int CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION

    public static final int CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES

    public static final int CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES

    public static final int CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES

    public static final int CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY

    public static final int CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY

    public static final int CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY

    public static final int CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP

    public static final int CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

    public static final int CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT

    public static final int CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT

    public static final int CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP

    public static final int CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

    public static final int CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT

    public static final int CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT

    public static final int CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

    public static final int CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT

    public static final int CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT

    public static final int CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT

    public static final int CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT

    public static final int CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT

    public static final int CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT

See Also:
  Constant Field Values
(Unpublished)

### CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY

    public static final int CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY

See Also:
  Constant Field Values
(Unpublished)

### DEFAULT_RENDERER

    public static final java.lang.String DEFAULT_RENDERER

See Also:
  Constant Field Values
(Unpublished)

### m_Session

    protected S_LibrarySession m_Session

(Unpublished)

### m_Id

    protected java.lang.Long m_Id

(Unpublished)

### m_ClassId

    protected java.lang.Long m_ClassId

(Unpublished)

Constructor Detail

### S_LibraryObject

    protected S_LibraryObject(S_LibrarySession session,
                              S_LibraryObjectData data)
                       throws IfsException

  Constructs a S_LibraryObject object. This constructor is called for objects that already exist in the database.

  Parameters:
    `session` - current S_LibrarySession
    `data` - the object's data
  Throws:
    `IfsException`
  (Published)

### S_LibraryObject

    protected S_LibraryObject(S_LibrarySession session)
                       throws IfsException

  Construct a S_LibraryObject object that does not yet exist inthe database. A create() method needs to be successfully invoked in order to transform this instance into a "real" one.

  Parameters:
    `session` - current S_LibrarySession
  Throws:
    `IfsException`
  (Unpublished)

### S_LibraryObject

    protected S_LibraryObject(S_LibrarySession session,
                              java.lang.Long classId)
                       throws IfsException

  This constructor is called during object creation (i.e., this Library Object does not yet exist in the database).

  Parameters:
    `session` - current S_LibrarySession
  Throws:
    `IfsException`
  (Published)

Method Detail

### getId

    public java.lang.Long getId()
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the object's numeric ID (a long).

  Specified by:
    `getId` in interface `LibraryObjectInterface`
  Returns:
    the object's Identifier.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClassId

    public java.lang.Long getClassId()
                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the object's class ID (a long). This is effectively the same as `getClassObject().getId();`

  Specified by:
    `getClassId` in interface `LibraryObjectInterface`
  Returns:
    the object's class Identifier.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### equals

    public boolean equals(S_LibraryObject item)
                   throws IfsException

  Description copied from class: `S_LibraryObject`
  Compares whether two LibraryObjects are the same IFS object. The comparison returns true only if the specified object is not null and only if both objects refer to an object that is not freed.

  Returns:
    true if the objects have the same Id.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### hashCode

    public int hashCode()

  Description copied from class: `S_LibraryObject`
  Returns a hashcode value for the LibraryObject.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    hashcode value
  (Published)

### dispose

    public void dispose()
                 throws IfsException

  Description copied from class: `S_LibraryObject`
  Disposes this instance, by nulling the Id and Class Id. This is called in reaction to notification that the underlying instance has been freed in the database.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### invalidateState

    public void invalidateState()
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Invalidates any information cached for this object.

  This will clear any entry in the committed data cache, and places a "dirty" entry on the current uncommitted data frame. This method is meant to be overridden by subclasses, which will invoke super.invalidateState() and then clear any member variables or other cached information associated with the object.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getClassData

    protected S_ClassObjectData getClassData()
                                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the object's class's Data object.

  Returns:
    the object's class's Data object
  Throws:
    `IfsException`
  (Unpublished)

### getClassObject

    public final S_ClassObject getClassObject()
                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the object's ClassObject.

  Returns:
    the object's ClassObject
  Throws:
    `IfsException`
  (Published)

### getClassName

    public java.lang.String getClassName()
                                  throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the object's class's name.

  Returns:
    the object's class's name
  Throws:
    `IfsException`
  (Unpublished)

### getName

    public java.lang.String getName()
                             throws IfsException

  Description copied from class: `S_LibraryObject`
  Returns the Name of this object, or null of this object does not have a NAME attribute.

  Returns:
    the name of this object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### hasNameAttribute

    public boolean hasNameAttribute()
                             throws IfsException

  Description copied from class: `S_LibraryObject`
  Returns true if this object is an instance of a class that has a NAME attribute, and false otherwise.

  Returns:
    true if the object has a NAME attribute.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### deriveUppercasedAttribute

    protected void deriveUppercasedAttribute(S_LibraryObjectDefinition def,
                                             java.lang.String attrname,
                                             java.lang.String derivedAttrame)
                                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Derives a system-set attribute from a base attribute, if this base attribute is defined in the specified definition. This is used, for example, to set the UNIQUENAME attribute of various classes to be the same as the name attribute forced to upper case. Do not derive a new name if the uniqquename value is already specified on the def.

  Parameters:
    `def` - current object definition
    `attrname` - name of the base attribute
    `derivedAttrame` - name of the derived attribute
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### deriveOwnerUniqueName

    protected java.lang.String deriveOwnerUniqueName(AttributeValue avName,
                                                     AttributeValue avOwner)
                                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Derives a "owner based unique name", which is a composite of an object which acts as an owner for scoping purposes, and the object name. The form of the composite is . The delimiter defaults to "-". The name is forced to uppercase. For example, for an owning objcet with ID 1234 and a name of notf.html, the derived owner unique name would be "1234-NOTF.HTML". If either of the specified attribute values are null or contain null values, the returned string is null.

  Parameters:
    `avName` - attribute value for the name
    `avOwner` - attribute value for the owner
  Returns:
    the derived unique name, or null if either the name or owner attributes specified are null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### deriveOwnerUniqueName

    protected java.lang.String deriveOwnerUniqueName(AttributeValue avName,
                                                     AttributeValue avOwner,
                                                     java.lang.String delim)
                                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Derives a "owner based unique name", which is a composite of an object which acts as an owner for scoping purposes, and the object name. The form of the composite is . The delimiter defaults to "-". The name is forced to uppercase. For example, for an owning objcet with ID 1234 and a name of notf.html, the derived owner unique name would be "1234-NOTF.HTML". If either of the specified attribute values are null or contain null values, the returned string is null.

  Parameters:
    `avName` - attribute value for the name
    `avOwner` - attribute value for the owner
    `delim` - the delimiter to use that separates the owner from the name
  Returns:
    the derived unique name, or null if either the name or owner attributes specified are null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSession

    public S_LibrarySession getSession()
                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Returns the current S_LibrarySession.

  Returns:
    the current LibrarySession
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSessionInterface

    public LibrarySessionInterface getSessionInterface()
                                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the LibrarySessionInterface for this S_LibraryObject.

  Specified by:
    `getSessionInterface` in interface `LibraryObjectInterface`
  Returns:
    the session interface
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getService

    protected S_LibraryService getService()
                                   throws IfsException

  Description copied from class: `S_LibraryObject`
  getService() - return the S_LibraryService which created the S_LibrarySession from which this object was created.

  Returns:
    the S_LibraryService from which this object was created.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getData

    protected S_LibraryObjectData getData()
                                   throws IfsException

  Description copied from class: `S_LibraryObject`
  Returns the data representation of the object

  Returns:
    the data representation of the object
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### toString

    public java.lang.String toString()

  Description copied from class: `S_LibraryObject`
  If this is an instance of a class that has a name attribute, return getName(); else, return super.toString().

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the name of the object.
  (Published)

### getAttribute

    public final AttributeValue getAttribute(java.lang.String attr_name)
                                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Return an AttributeValue object that holds the value of the requested attribute.

  Parameters:
    `attr_name` - the name of the Attribute
  Returns:
    the requested AttributeValue
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttributeByUpperCaseName

    public final AttributeValue getAttributeByUpperCaseName(java.lang.String attr_name)
                                                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the attribute value for the specified attribute. Avoids the cost of toUpperCase on the attribute name.

  Specified by:
    `getAttributeByUpperCaseName` in interface `LibraryObjectInterface`
  Parameters:
    `attr_name` - the attribute name; must be all upper case
  Returns:
    the AttributeValue
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEventualAttributeByUpperCaseName

    protected AttributeValue getEventualAttributeByUpperCaseName(java.lang.String attrname,
                                                                 S_LibraryObjectDefinition def)
                                                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the attribute value for the specified attribute from either the target object or from the specified definition. If the target object does not yet exist in the database, this will return the setting in the definition for this attribute, or null if this attribute is not set. If the target object does already exist, it will return the value set in the definition if specified, or the value on the existing object if not specified. This method also avoids the cost of forcing the specified attribute name to upper case by assuming that the caller is specifying an upper cased attribute name.

  Parameters:
    `attrname` - the attribute name; must be all upper case
    `def` - the definition
  Returns:
    the AttributeValue
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getObjectReferenceAttribute

    protected final ObjectReferenceAttributeValue getObjectReferenceAttribute(java.lang.String attrname)
                                                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the value of a ObjectReference attribute.

  Parameters:
    `attrname` - the attribute name
  Returns:
    the Serializable value
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setAttribute

    public void setAttribute(java.lang.String attr_name,
                             AttributeValue attr_value)
                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Set the object's attribute to the specified value.

  The value is set in the object's cache as well as in the CM SDK server. This variant will set the attribute's name in the AttributeValue to the name argument provided.

  Parameters:
    `attr_name` - the name of the Attribute
    `attr_value` - the desired value of the Attribute
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttribute

    public void setAttribute(AttributeValue attr_value)
                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Set the object's attribute to the specified value.

  The value is set in the object's cache as well as in the CM SDK server.

  Parameters:
    `attr_value` - the desired name & value of the Attribute
  Throws:
    `IfsException` - if operation fails.
  (Published)

### renderAsStream

    public final java.io.InputStream renderAsStream(java.lang.String rendererType,
                                                    java.lang.String rendererName,
                                                    java.util.Hashtable options)
                                             throws IfsException

  Deprecated. iFS 9.0.3 see release notes for more information

  Description copied from class: `S_LibraryObject`
  Renders this LibraryObject as an InputStream.

  The rendererType and rendererName together determine which Renderer implementation is to be used as follows:

  If rendererName is not null, the Policy named rendererName for the operation specified by rendererType is obtained. The fully-qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  If rendererName is null, the default Policy for this LibraryObject for the operation specified by rendererType is obtained. The fully- qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  The values in the options Hashtable must be serializable.

  Parameters:
    `rendererType` - the type of the desired Renderer
    `rendererName` - the name of the desired Renderer
    `options` - any Renderer-specific options
  Returns:
    the InputStream
  Throws:
    `IfsException` - (IFS-30110) if the operation fails
  (Unpublished)

### renderAsReader

    public final java.io.Reader renderAsReader(java.lang.String rendererType,
                                               java.lang.String rendererName,
                                               java.util.Hashtable options)
                                        throws IfsException

  Deprecated. iFS 9.0.3 see release notes for more information

  Description copied from class: `S_LibraryObject`
  Renders this LibraryObject as a Reader.

  The rendererType and rendererName together determine which Renderer implementation is to be used as follows:

  If rendererName is not null, the Policy named rendererName for the operation specified by rendererType is obtained. The fully-qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  If rendererName is null, the default Policy for this LibraryObject for the operation specified by rendererType is obtained. The fully- qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  The values in the options Hashtable must be serializable.

  Parameters:
    `rendererType` - the type of the desired Renderer
    `rendererName` - the name of the desired Renderer
    `options` - any Renderer-specific options
  Returns:
    the Reader
  Throws:
    `IfsException` - (IFS-30110) if the operation fails
  (Unpublished)

### setAttributes

    protected void setAttributes(S_LibraryObjectDefinition def)
                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Set the object's attributes to the specified values. The values are set in the object's cache as well as in the DM server. Each AttributeValue must have its name set. If the AttributeValues do not have their name set, then you must use the other variant of this call. Note that this method is preferred as it is more efficient. It is also more efficient to call setAttributes() (plural) instead of the singular setAttribute variant when you have more than one attribute to set at one time.

  Parameters:
    `def` - the server-side definition class that holds the attribute changes
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### update

    public void update(OperationState opState,
                       S_LibraryObjectDefinition def)
                throws IfsException

  Description copied from class: `S_LibraryObject`
  update an object in the context of an Operation.

  Parameters:
    `opState` - Operation state
    `def` - the server-side definition class that holds the attribute changes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### preUpdate

    protected final void preUpdate(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_LibraryObject`
  perform pre-update operations on an object.

  Parameters:
    `opState` - Operation state
    `def` - the server-side definition class that holds the attribute changes
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### verifyWriteableTransactionInProgress

    protected final void verifyWriteableTransactionInProgress()
                                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  verify that we're in a Writeable transaction. Throw an exception if not.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### postInsert

    protected final void postInsert(OperationState opState,
                                    S_LibraryObjectDefinition def)
                             throws IfsException

  Description copied from class: `S_LibraryObject`
  operations to be performed after inserting a new object. This is overridden by classes that need to perform operations after successfully inserting the rows for the newly created instance.

  Parameters:
    `def` - the S_LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreUpdate

    protected void extendedPreUpdate(OperationState opState,
                                     S_LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed before updating an object. This is overridden by classes that need to perform operations before udpating this object in the database.

  Parameters:
    `opState` - Operation state
    `def` - the server-side definition class that holds the attribute changes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### postUpdate

    protected void postUpdate(OperationState opState,
                              S_LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed after updating an object.

  This is overridden by classes that need to perform operations after successfully inserting the rows for the newly created instance.

  Parameters:
    `opState` - the Operation state
    `def` - the S_LibraryObjectDefinition that contains the updates.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPostUpdate

    protected void extendedPostUpdate(OperationState opState,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `S_LibraryObject`
  Extended operations to be performed after updating an object.

  This is overridden by classes that need to perform operations after updating this object in the database, but before commit.

  Parameters:
    `opState` - the Operation state
    `def` - the S_LibraryObjectDefinition that contains the updates.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### preFree

    protected final void preFree(OperationState opState,
                                 S_LibraryObjectDefinition def)
                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed before freeing an object.

  This is overridden by classes that need to perform operations after successfully deleting the rows for the freed instance.

  Parameters:
    `opState` - the Operation state
    `def` - the S_LibraryObjectDefinition that contains the free options.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### preInsert

    protected final void preInsert(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_LibraryObject`
  Prepare operation for create instance.

  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### executePolicyOperation

    public void executePolicyOperation(java.lang.String opName,
                                       OperationState opState,
                                       S_LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Execute Policy operation.

  Parameters:
    `opName` - the operation name
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if the operation fails.
  (Unpublished)

### associatedPreInsert

    protected void associatedPreInsert(OperationState opState,
                                       S_LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `S_LibraryObject`
  an extensibility point, subclasses override to have preinsert extensibility after extendedPreInsert and manipulate associated objects

  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### associatedPostInsert

    protected void associatedPostInsert(OperationState opState,
                                        S_LibraryObjectDefinition def)
                                 throws IfsException

  Description copied from class: `S_LibraryObject`
  an extensibility point, subclasses override to have postinsert extensibility after extendedPostInsert and manipulate associated objects

  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### associatedPostFree

    protected void associatedPostFree(OperationState opState,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `S_LibraryObject`
  An extensibility point, subclasses override to have postFree extensibility after extendedPostFree and manipulate associated objects

  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### postFree

    protected void postFree(OperationState opState,
                            S_LibraryObjectDefinition def)
                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed after freeing an object. Remove ourselves from the S_LO cache, perform any extensible followup operations, and last clear our Ids

  Parameters:
    `opState` - the operation state
    `def` - the LibraryObjectDefinition that contains the free settings .
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### issueCascade

    protected void issueCascade(S_LibraryObject target,
                                OperationState opState,
                                S_LibraryObject source,
                                int cascadeType,
                                S_LibraryObjectDefinition sdef,
                                java.lang.Object customArg)
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Issue a cascaded operation request to another object. This results in a handleCascade() call to the target object.

  Parameters:
    `target` - object to receive this cascade request
    `opState` - originating operation state
    `source` - object initiating this cascade request (usually this).
    `cascadeType` - type of cascade request
    `sdef` - original Definition object
    `customArg` - any custom parameter.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### handleCascade

    protected void handleCascade(OperationState opState,
                                 S_LibraryObject source,
                                 int cascadeType,
                                 S_LibraryObjectDefinition sdef,
                                 java.lang.Object customArg)
                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Handle a cascaded operation initiated by (usually) another object. This is overridden by classes to add custom handlers. It is ok if no class handles the cascade (that is implied to mean "no action needed").

  Parameters:
    `opState` - originating operation state
    `source` - object initiating this cascade request (not necessarily the original object)
    `cascadeType` - type of cascade request
    `sdef` - original Definition object
    `customArg` - any custom parameter.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFree

    protected void cascadeFree(OperationState opState,
                               S_LibraryObjectDefinition def)
                        throws IfsException

  Description copied from class: `S_LibraryObject`
  cascade operations to be performed before freeing an object. This is overridden by classes that need to perform operations before successfully freeing the rows for the freed instance.

  Parameters:
    `opState` - current operation state
    `def` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeUpdate

    protected void cascadeUpdate(OperationState opState,
                                 S_LibraryObjectDefinition def)
                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Cascade operations to be performed before updating an object. This is overridden by classes that need to perform operations before successfully updating the rows for the freed instance.

  Parameters:
    `opState` - current operation state
    `def` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeCopy

    protected void cascadeCopy(OperationState opState,
                               S_LibraryObjectDefinition def,
                               S_LibraryObject clone)
                        throws IfsException

  Description copied from class: `S_LibraryObject`
  Cascade operations to be performed before copying an object. This is overridden by classes that need to perform operations before successfully copying the rows for the freed instance.

  Parameters:
    `opState` - current operation state
    `def` - object definition
    `clone` - the copy of the target object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreFree

    protected void extendedPreFree(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed before freeing an object. This is overridden by classes that need to perform operations before successfully deleting the rows for the freed instance.

  Parameters:
    `opState` - current operation state
    `def` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPostFree

    protected void extendedPostFree(OperationState opState,
                                    S_LibraryObjectDefinition def)
                             throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed after freeing an object. This is overridden by classes that need to perform operations after successfully deleting the rows for the freed instance.

  Parameters:
    `opState` - current operation state
    `def` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPreInsert

    protected void extendedPreInsert(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Extensibility point to perform actions prior to the creation of a new CM SDK object.

  The current operation state for the Create operation is passed along with the definition object that holds the attributes and options used in creating the object.

  This method is typically overridden by subclasses that add attribute settings to the definition prior to the object being created. At this point, the ID is not set on the target instance. It can also be used to perform validation; this method should throw an exception to prevent the object creation from taking place if the definition specification is invalid.

  Parameters:
    `opState` - current operation state
    `sdef` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPostInsert

    protected void extendedPostInsert(OperationState opState,
                                      S_LibraryObjectDefinition sdef)
                               throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed after creating an object. This is overridden by classes that need to perform operations after successfully creating the rows for the new instance.

  Parameters:
    `opState` - current operation state
    `sdef` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPreCopy

    protected void extendedPreCopy(OperationState opState,
                                   S_LibraryObjectDefinition sdef)
                            throws IfsException

  Description copied from class: `S_LibraryObject`
  Operations to be performed before creating a copy of an object. This is overridden by classes that need to perform operations before successfully creating the rows for the new instance.

  Parameters:
    `opState` - current operation state
    `sdef` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getDefinition

    protected S_LibraryObjectDefinition getDefinition()
                                               throws IfsException

  Description copied from class: `S_LibraryObject`
  Construct a S_LibraryObjectDefinition object that represents the target object.

  Returns:
    the S_LibraryObjectDefinition that represents the target object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### deriveDefinition

    protected void deriveDefinition(S_LibraryObjectDefinition def)
                             throws IfsException

  Description copied from class: `S_LibraryObject`
  Add to the S_LibraryObjectDefinition for this class.

  This this called by getDefinition() on S_LibraryObject. All classes that extend this should call super.deriveDefinition() before applying any class-specific changes to the S_LibraryObjectDefinition object.

  Parameters:
    `def` - the S_LibraryObjectDefinition that contains the definition of the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### clonePublicObjectAttribute

    protected void clonePublicObjectAttribute(OperationState opState,
                                              S_LibraryObjectDefinition sdef,
                                              java.lang.String attrname)
                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Copies an attribute in a definition.

  Parameters:
    `opState` - The operation state.
    `sdef` - The definition for the new copy.
    `attrname` - The name of the attribute to copy.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### copy

    public S_LibraryObject copy(OperationState opState)
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Make a copy of the target object.

  Parameters:
    `opState` - the OperationState
  Returns:
    the copied object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### copy

    public S_LibraryObject copy(OperationState opState,
                                S_LibraryObjectDefinition def)
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Make a copy of the target object.

  Parameters:
    `opState` - the OperationState
    `def` - any modifications to make to the copied object
  Returns:
    the copied object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### free

    protected void free(OperationState opState)
                 throws IfsException

  Description copied from class: `S_LibraryObject`
  Permanently delete an object.

  Parameters:
    `opState` - the OperationState
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### free

    public void free(OperationState opState,
                     S_LibraryObjectDefinition def)
              throws IfsException

  Description copied from class: `S_LibraryObject`
  Permanently delete an object.

  Parameters:
    `opState` - The operation state.
    `def` - The free options.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLibraryConnection

    protected LibraryConnection getLibraryConnection()
                                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Return the database connection.

  Returns:
    the low-level connection context
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key)
                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the resource string for the specified key.

  The method looks-up the key in each extended resource bundle. If no extended resource bundle contains the key, the default resource bundle (LibraryResources) is used.

  Parameters:
    `key` - the resource bundle key
  Returns:
    the resource string
  Throws:
    `IfsException` - IFS-12001 if the operation fails
  (Unpublished)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key,
                                              java.lang.Object[] params)
                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.

  The method looks-up the key using `getResourceString(key)`. Next, `java.text.MessageFormat` is used to substitute the parameters specified by `params` into the key's value. If a string element of `params` is delimited by brackets, i.e. "`{param}`", then that element is replaced with the value returned by `getResourceString("param")` before being passed to `MessageFormat`.

  Parameters:
    `key` - the resource bundle key
    `params` - an array of Objects to be substituted into the resource bundle message using using `java.text.MessageFormat`
  Returns:
    the formatted resource string
  Throws:
    `IfsException` - IFS-12006 if the operation fails
  (Unpublished)

### isTraced

    public final boolean isTraced(int channel,
                                  int level)
                           throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets whether tracing is enabled for the specified channel and level.

  Specified by:
    `isTraced` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
  Returns:
    whether tracing is enabled
  Throws:
    `IfsException` - (IFS-11201) if the channel is invalid
  (Published)

### trace

    public final void trace(int channel,
                            int level,
                            java.lang.String payload)

  Description copied from class: `S_LibraryObject`
  Issues a trace request to the trace logger.

  Specified by:
    `trace` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
    `payload` - a string containing any additional information to be placed in the trace log
  (Published)

### getTraceLogger

    public final TraceLogger getTraceLogger()
                                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the trace logger of this object's session.

  Specified by:
    `getTraceLogger` in interface `Traceable`
  Returns:
    the trace logger
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### postEvent

    public final void postEvent(int eventType,
                                int eventStatus)
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Posts an event of the specified type and status.

  Parameters:
    `eventType` - the event type; must be one of the event type constants enumerated in IfsEvent
    `eventStatus` - the event status; must be one of the event status constants enumerated in IfsEvent
  Throws:
    `IfsException` - if the operation fails
  (Published)

### postEvent

    public final void postEvent(int eventType,
                                int eventSubtype,
                                int eventStatus,
                                long longPayload)
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Posts an event of the specified type, subtype, and status.

  Parameters:
    `eventType` - the event type; must be one of the event type constants enumerated in IfsEvent
    `eventSubtype` - the event subtype; the meaningful values are `eventType` variant
    `eventStatus` - the event status; must be one of the event status constants enumerated in IfsEvent
    `longPayload` - the long payload; the meaningful values are `eventType` variant
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleEvent

    public void handleEvent(IfsEvent event)
                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Handles the specified event.

  Specified by:
    `handleEvent` in interface `IfsEventHandler`
  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEffectivePolicyListElements

    public java.util.Vector getEffectivePolicyListElements(java.lang.String operation)
                                                    throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the set of policies, as PolicyListElements, applied to this LibraryObject, either explicitly (through its PolicyLists) or implicitly (through the ClassPolicyLists of its classobject hierarchy) for the specified operation.

  The PolicyListElements are returned in SORTSEQUENCE order. If more than one PolicyListElement has a particular SORTSEQUENCE value, a PolicyListElement introduced by the object's PolicyLists precedes a PolicyListElement introduced by a ClassPolicyList. If more than one PolicyListElement is introduced by a ClassPolicyList for a particular SORTSEQUENCE value, a PolicyListElement introduced by a classobject precedes the PolicyListElements introduced by the superclasses of that classobject. If more than one PolicyListElement is introduced by a object-level PolicyList for a particular SORTSEQUENCE value, the array ordering of the PolicyList objects in the PolicyLists attribute is used to determine precedence.

  Parameters:
    `operation` - the operation of interest, or null for all operations
  Returns:
    a Vector of S_PolicyListElement objects
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEffectivePolicyActionContexts

    protected java.util.Vector getEffectivePolicyActionContexts(java.lang.String operation)
                                                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the set of policies, as PolicyActionContexts, applied to this LibraryObject, either explicitly (through its PolicyLists) or implicitly (through the ClassPolicyLists of its classobject hierarchy) for the specified operation.

  The PolicyListElements are returned in SORTSEQUENCE order. If more than one PolicyListElement has a particular SORTSEQUENCE value, a PolicyListElement introduced by the object's PolicyLists precedes a PolicyListElement introduced by a ClassPolicyList. If more than one PolicyListElement is introduced by a ClassPolicyList for a particular SORTSEQUENCE value, a PolicyListElement introduced by a classobject precedes the PolicyListElements introduced by the superclasses of that classobject. If more than one PolicyListElement is introduced by a object-level PolicyList for a particular SORTSEQUENCE value, the array ordering of the PolicyList objects in the PolicyLists attribute is used to determine precedence.

  Parameters:
    `operation` - the operation of interest, or null for all operations
  Returns:
    a Vector of PolicyActionContexts objects
  Throws:
    `IfsException` - if the operation fails
  (Published)

### determinePolicy

    protected S_Policy determinePolicy(java.lang.String operationName,
                                       S_LibraryObjectDefinition def)
                                throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `S_LibraryObject`
  Determines policy, if any, from the object's Definition instance, or the object's PolicyBundle, or from its ClassObject, or one of its ClassObject's superclasses. Return null if no policy exists for this operation.

  Parameters:
    `operationName` - Operation name
    `def` - definition instance (PolicyBundle can be specified as an attribute)
  Returns:
    the Policy for the requested operation, or null if no specific Policy.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### determinePolicy

    protected S_Policy determinePolicy(java.lang.String operationName)
                                throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `S_LibraryObject`
  Determines policy, if any, from the object's PolicyBundle or from its ClassObject, or one of its ClassObject's superclasses. Return null if no policy exists for this operation.

  Parameters:
    `operationName` - Operation name
  Returns:
    the Policy for the requested operation, or null if no specific Policy.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### findPolicyFromPropertyBundleAv

    protected static S_Policy findPolicyFromPropertyBundleAv(S_LibrarySession sess,
                                                             AttributeValue av,
                                                             java.lang.String operationName)

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `S_LibraryObject`
  ???

  (Unpublished)

### invokeOperation

    public java.lang.Object invokeOperation(OperationContext opContext)
                                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Invoke an operation.

  Parameters:
    `opContext` - the operation specification
  Returns:
    the result of the operation
  Throws:
    `IfsException` - if the operation fails
  (Published)

### invokePolicyMethod

    protected java.lang.Object invokePolicyMethod(java.lang.String methodName,
                                                  java.lang.Object[] args,
                                                  java.lang.String[] argClassPaths)
                                           throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `S_LibraryObject`
  Dynamically invoke a method indicated by policy

  Parameters:
    `methodName` - method name
  Returns:
    the Policy for the requested operation, or null if no specific Policy.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createInstance

    protected S_LibraryObjectData createInstance(OperationState opState,
                                                 S_LibraryObjectDefinition def)
                                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Create a new instance.

  Parameters:
    `def` - the LibraryObjectDefinition that contains the settings for the new instance.
  Returns:
    a Data object that corresponds to the new instance
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### deleteRows

    protected void deleteRows()
                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Delete the row from each table for this instance.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### updateRows

    protected void updateRows(S_LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Update the rows from each table for this instance.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### DYNLockRows

    public java.io.Serializable DYNLockRows(java.io.Serializable payload)
                                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Lock the rows from each table for this instance.

  Parameters:
    `payload` - ignored
  Returns:
    null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### lockRows

    protected void lockRows()
                     throws IfsException

  Description copied from class: `S_LibraryObject`
  Lock the rows from each table for this instance.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### insertRows

    protected void insertRows(S_LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Update the rows from each table for this instance.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isBroadcastCreateEventEnabled

    protected boolean isBroadcastCreateEventEnabled()
                                             throws IfsException

  Description copied from class: `S_LibraryObject`
  Returns indication as to whether create events should be posted.

  Overridden by subclasses that require create events (most do not).

  Returns:
    true if create event should be posted
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### insertRow

    protected void insertRow(AttributeValue[] avs,
                             S_ClassObjectData clssdata)
                      throws IfsException

  Description copied from class: `S_LibraryObject`
  ???

  Throws:
    `IfsException`
  (Unpublished)

### clearArrayTypeAttributeValues

    protected static void clearArrayTypeAttributeValues(S_Attribute attribute,
                                                        S_LibrarySession session)
                                                 throws IfsException

  Description copied from class: `S_LibraryObject`
  This variant is used by S_ClassObject.removeAttribute. It really should be on S_LS, but we'll keep it here as a static to have all these methods in one place.

  Throws:
    `IfsException`
  (Unpublished)

### checkSettable

    protected void checkSettable(S_LibraryObjectDefinition def)
                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Checks to ensure the attributes in the specfied definition are user settable.

  Parameters:
    `def` - the definition
  Throws:
    `IfsException` - (IFS-30019) if an attribute in the definition is not settable
  (Unpublished)

### insertReferenceAttributes

    protected void insertReferenceAttributes(S_LibraryObjectDefinition def)
                                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Resolve any Reference attributes into content and content references during object creation.

  Parameters:
    `def` - the definition
  Throws:
    `if` - operation fails
    `IfsException`
  (Unpublished)

### verifyCanCreate

    protected void verifyCanCreate(S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_LibraryObject`
  Verifies that the instance can be created. This is called as part of the createInstance sequence; some classes may do some additional verification prior to calling createInstance (e.g. for SchemaObjects). This method is overridden by S_PublicObject, S_SystemObject, and S_SchemaObject.

  Parameters:
    `def` - the definition
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanUpdate

    protected void verifyCanUpdate()
                            throws IfsException

  Description copied from class: `S_LibraryObject`
  Verifies that the instance can be updated. This is called as part of the update() sequence. External (e.g. bean-side) requests verify admin mode for non-PublicObjects prior to calling here.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanFree

    protected void verifyCanFree()
                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Verifies that the instance can be freed. This is called as part of the free() sequence. External (e.g. bean-side) requests verify admin mode for non-PublicObjects prior to calling here.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanGetContent

    protected void verifyCanGetContent(S_ContentObject co)
                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Verifies that the user has getContent permission on this object

  Parameters:
    `co` - the content object
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanSetContent

    protected void verifyCanSetContent()
                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Verifies that the user has setContent permission on this object

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanSetPolicy

    protected void verifyCanSetPolicy()
                               throws IfsException

  Description copied from class: `S_LibraryObject`
  Verifies that Policies can be updated on the instance. This is over ridden by S_PublicObject. It is a no op for system and schema objects.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### applyValueDefault

    protected void applyValueDefault(S_LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `S_LibraryObject`
  Sets default values for any attributes which have a ValueDefault and for which no value is specified in the definition.

  Parameters:
    `def` - the definition
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### determineValueDefault

    protected S_ValueDefault determineValueDefault(S_AttributeData attributeData,
                                                   S_LibraryObjectDefinition def)
                                            throws IfsException

  Description copied from class: `S_LibraryObject`
  return the ValueDefault that is in force for the specified Attribute data.

  Parameters:
    `attributeData` - the Attribute data
    `def` - the definition context
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### checkRequiredForInsert

    protected void checkRequiredForInsert(S_LibraryObjectDefinition def)
                                   throws IfsException

  Description copied from class: `S_LibraryObject`
  Checks whether all required attributes of the object being created have been set in the specified definition.

  Parameters:
    `def` - the definition
  Throws:
    `IfsException` - (IFS-30012) if a required attribute is null
  (Unpublished)

### determineClassDomain

    protected S_ClassDomain determineClassDomain(S_AttributeData attributeData,
                                                 S_LibraryObjectDefinition def)
                                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Return the ClassDomain that is in force for the specified Attribute data.

  Parameters:
    `attributeData` - the Attribute data
    `def` - the definition context
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### determineValueDomain

    protected S_ValueDomain determineValueDomain(AttributeValue av,
                                                 S_ClassObjectData classData,
                                                 S_LibraryObjectDefinition def)
                                          throws IfsException

  Description copied from class: `S_LibraryObject`
  Return the ValueDomain that is in force for the specified AttributeValue.

  Parameters:
    `av` - the AttributeValue
    `classData` - class data for this instance (can be null)
    `def` - the definition (for context by overriders)
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### copyVectorToLibraryObjectArray

    protected static void copyVectorToLibraryObjectArray(S_LibrarySession sess,
                                                         java.util.Vector vector,
                                                         S_LibraryObject[] objs)
                                                  throws IfsException

  Description copied from class: `S_LibraryObject`
  Fill the specified S_LibraryObject array with S_LibraryObjects constructed from a corresponding set of S_LibraryObjectData obejcts.

  Parameters:
    `sess` - session context
    `vector` - vector of data objects
    `objs` - array to copy the constructed obejcts into
  Throws:
    `IfsException`
  (Unpublished)

### constructIdArray

    protected static java.lang.Long[] constructIdArray(S_LibraryObject[] objs)
                                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Construct an array of object IDs from an array of S_LibraryObjects.

  Parameters:
    `objs` - the array of objects
  Returns:
    the array of object IDs
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructIdArray

    protected static java.lang.Long[] constructIdArray(java.util.Vector vector)
                                                throws IfsException

  Description copied from class: `S_LibraryObject`
  Construct an array of object IDs from a Vector of S_LibraryObjectData objects.

  Parameters:
    `vector` - the vector of S_LibraryObjectData
  Returns:
    the array of object IDs
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isInstanceOf

    public boolean isInstanceOf(S_ClassObject clss)
                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Determine if this is an instance of the specified S_ClassObject.

  Returns:
    true if this is an instance of the specified S_ClassObject.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getPropertyBundle

    public S_PropertyBundle getPropertyBundle()
                                       throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the S_PropertyBundle for this SystemObject.

  Returns:
    the PropertyBundle
  Throws:
    `IfsException`
  (Published)

### getPropertyValue

    public AttributeValue getPropertyValue(java.lang.String key)
                                    throws IfsException

  Description copied from class: `S_LibraryObject`
  Returns a property from the S_PropertyBundle associated with this instance.

  Parameters:
    `key` - the property's key
  Returns:
    the property value, or null if no property exists with that key
  Throws:
    `IfsException` - if the operation fails
  (Published)

### createDefaultPropertyBundle

    public S_PropertyBundle createDefaultPropertyBundle()
                                                 throws IfsException

  Description copied from class: `S_LibraryObject`
  Creates a PropertyBundle for a SystemObject or SchemaObject.

  Returns:
    the default PropertyBundle
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### createDefaultPolicyPropertyBundle

    public S_PolicyPropertyBundle createDefaultPolicyPropertyBundle()
                                                             throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `S_LibraryObject`
  Creates a PolicyPropertyBundle for a SystemObject or SchemaObject.

  Returns:
    the default PolicyPropertyBundle
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### getAuditEventFolderContext

    public S_Folder getAuditEventFolderContext()
                                        throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the folder context for the target of an Audit Event.

  Returns:
    the folder context for the target
  Throws:
    `IfsException` - if the operation fails

### getAuditDomainContext

    public java.lang.Long getAuditDomainContext()
                                         throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the domain context to use for auditing.

  Returns:
    the domain context for the target
  Throws:
    `IfsException` - if the operation fails

### getAuditCertificateName

    public java.lang.String getAuditCertificateName()
                                             throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets the name to use in an audit certificate.

  Returns:
    the name to use for an audit certificate for the target object
  Throws:
    `IfsException` - if the operation fails

### isAuditCertificateSecured

    public boolean isAuditCertificateSecured()
                                      throws IfsException

  Description copied from class: `S_LibraryObject`
  Gets whether an audit certificate for the target object should be secured, meabing it should be restricted to administrators.

  Returns:
    true if an audit certificate for the target object should be secured; false otherwise
  Throws:
    `IfsException` - if the operation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD